;-----------------------------INCLUDES-AND-DEFINITIONS------------------------------------------------;

#include "jdg86.h"
#ifndef GRAYLAYERS
#define GRAYLAYERS
GrayDraw1 = $FC00
GrayDraw2 = $F700
TempLine = _textShadow              ;$86df
PicCoor  = TempLine +1528           ;$80e7
offset   =  PicCoor +2                  ;$80e9
NASR_Status = offset +1             ;$80ea
#define PAGE1_BPL1         $3C
#define PAGE1_BPL2         $37
_user_int_ram EQU $d2fd
VideoDraw = $F300
#endif

;------------------------------MAIN-PROGRAM------------------------------------------------------------;

.org $d748                  ;_asm_exec_ram
    nop
    jp ProgStart
    .dw 1
    .dw ShellText
    .dw ShellIcon

ShellText:
    .db "Starcraft Logo Background Pic",0

ShellIcon:
    .db 8
    .db 1
    .db %01111110
    .db %10000001
    .db %10100101
    .db %10000001
    .db %10100101
    .db %10011001
    .db %10000001
    .db %01111110

ProgStart:
    call _runindicoff
    call ClearPage      ; clear both grayscale layers
    call OpenGray           ; open grayscale
    ld bc,$0000
    ld hl,DarkLayer
    call NASR2_4
    call _clrLCD
    ld hl,TEXT
    ld bc,$0000
    ld (_penCol),bc
    jp _vputs

TEXT:
    .db "Starcraft Logo Background Installed",0

OpenGray:
    res 2,(iy+$23)
    ld hl,IntRoutine
    ld de,_user_int_ram+1
    ld bc,InterruptMemEnd-IntRoutine
    ldir
    ld a,(_user_int_ram+1)
    ld hl,_user_int_ram+($28*1)
    add a,(hl)
    ld hl,_user_int_ram+($28*2)
    add a,(hl)
    ld hl,_user_int_ram+($28*3)
    add a,(hl)
    ld hl,_user_int_ram+($28*4)
    add a,(hl)
    ld hl,_user_int_ram+($28*5)
    add a,(hl)
    ld (_user_int_ram),a
    xor a
    ld (IntCounter), a
    ld (UserCounter), a
    ld de, IntData
    ld hl, SourceIntData
    ld bc, 2
    ldir
    set 2,(iy+$23)
    ret

IntRoutine:
    push af
    push hl
    in a,(3)
    bit 1,a
    jr z,EndIntRoutine
    ld hl, UserCounter
    inc (hl)
    ld hl, IntData
    ld a,(IntCounter)
    cp 5
    jr z,DisplayLast
    cp 3
    jr c,DisplayBpl1
    jr DisplayBpl2

DisplayBpl1:
    inc a
    ld (IntCounter),a
    ld a, (hl)
    out (0),a
    jr EndIntRoutine

DisplayBpl2:
    inc a
    ld (IntCounter),a
    inc hl
    ld a, (hl)
    out (0),a
    jr EndIntRoutine

DisplayLast:
    ld a, (hl)
    out (0), a
    xor a
    ld (IntCounter),a

EndIntRoutine:
    ld a,(UserCounter)
    cp 41
    jr z,EndIntRoutine2
    pop hl
    pop af
    ret
EndIntRoutine2:
    xor a
    ld (UserCounter),a
    pop hl
    pop af
    ret

InterruptMemEnd:

;--------------------------------------------------------------------------;

GraySprite:
    push hl
    pop ix
    call FindAddress
GraySpriteE:
    push hl
    push ix
    ld de,GrayDraw1
    add hl,de
    ld a,16
    ld (RenderSpriteM),a
    call RenderSprite
    ld a,8
    ld (RenderSpriteM),a
    pop ix
    pop hl
    ld de,GrayDraw2
    add hl,de
    ld de,$0008
    add ix,de

RenderSprite:
RenderSpriteCV = $+1
    ld b,8
RenderSpriteL:
    push bc
    ld a,(ix+8)
RenderSpriteM = $-1
    cpl
    ld b,a
    ld d,(ix)
    inc ix
    ld a,c
    ld c,$ff
    ld e,0
    or a
    jr z,RenderSpriteD
RenderSpriteS:
    srl d
    rr e
    scf
    rr b
    rr c
    dec a
    jr nz,RenderSpriteS
RenderSpriteD:
RenderSpriteCL =$
    ld a,b
    and (hl)
    or d
    ld (hl),a
    inc hl
RenderSpriteCR =$
    ld a,c
    and (hl)
    or e
    ld (hl),a
    ld de,15
    add hl,de
    pop bc
    djnz RenderSpriteL
    ret

FindAddress:
    ld a,c
    add a,a
    add a,a
    ld l,a
    ld h,0
    add hl,hl
    add hl,hl
    ld a,b
    and %11111000
    rra
    rra
    rra
    or l
    ld l,a
    ld a,b
    and %00000111
    ld c,a
    ret

;tables needed :)

IntCounter              equ _user_int_ram+InterruptMemEnd-IntRoutine+2
IntData                 equ _user_int_ram+InterruptMemEnd-IntRoutine+3
UserCounter             equ _user_int_ram+InterruptMemEnd-IntRoutine+5

SourceIntData:
.db PAGE1_BPL1, PAGE1_BPL2

Pages:
.dw $FC00, $F700

;-----------------------------------END-OF-GRAYSCALE-HANDLER----------------------;
;----------------------------------START-OF-GRAYSCALE-PUTSPRITE----------------------;
;NASR2_3 and NASR2_4
;made by Haroon I
;
;input: bc-coords for sprite
;   hl-sprite name
;
;   sprites have to be in this format:
;       .db width/8,1,height
;   instead of
;       .db width,height
;
;output:
;   no registers trashed/destroyed
;
; if you want to use use _textShadow start you variables at
; _textShadow + 1533

CloseGray:
    res 2, (iy+$23)
    ld a, $3C
    out (0), a
ClearPage:
    ld hl, (Pages)
    call Clear1024
    ld hl, (Pages+2)
Clear1024:
    ld d, h
    ld e, l
    inc de
    ld (hl), 0
    ld bc, 1024
    ldir
    ret

NASR2_4:    
        push bc
        ex de,hl
        call FIND_PIXEL
        ld bc,GrayDraw2
normality:
        add hl,bc
        ld (PicCoor),hl
        ex de,hl
        ld b,$ff
Patch23:
        rla
        inc b
        jr nc,Patch23
        ld c,(hl)
        inc hl
        ld a,b   
        ld e,c
        cp (hl)
        jr c,DS123
        inc e
DS123:
        inc hl
        ld a,(hl)
        ld d,a
        inc hl
YLoop23:            
        push bc 
        push de
        ld b,8
        ex de,hl
        ld hl,TempLine
InitTempLineLoop23:
        ld (hl),0
        inc hl
        djnz InitTempLineLoop23
        ex de,hl
        ld b,0
        ld de,TempLine
        ldir
        pop de
        pop bc
        ld a,b
        cp 0 
        call nz,ShiftLine23   
        push bc
        push hl
        push de
        ld b,e
        ld hl,(PicCoor)
        ld de,16
        push hl
        add hl,de
        ld (PicCoor),hl
        pop hl
        ld de,TempLine
        ex de,hl
LoadSpriteLoop23:
    ld a,(NASR_Status)
    cp 1
    jp z,status3
status4:
    ld a,(hl)
        ex de,hl
        xor (hl)
        ld (hl),a
        ex de,hl
status2:
    inc de
        inc hl
        djnz LoadSpriteLoop23
        pop de
        pop hl
        pop bc
        dec d
        jp nz,YLoop23
        pop bc
        ret

ShiftLine23:
        push hl
        push bc 
SpriLoop123:
        ld a,b    
        ld hl,TempLine
        ld b,e
        and a
SpriLoop223:        
        rr (hl)
        inc hl
        djnz SpriLoop223
        ld b,a
        djnz SpriLoop123        
        pop bc
        pop hl
        ret
status3:
    ld a,(hl)
        ex de,hl
    or (hl)
        ld (hl),a
        ex de,hl
    jp status2

;-----------------------------------------END-GRAYSCALE-PUTSPRITE--------------------------;
;-------------------------------------SAME-OLD-FINDPIXEL-ROUTINE---------------------------;
;best one out though (to me(really quick))

FIND_PIXEL:
        push bc
        push de
        ld hl,ExpTable
        ld d,0
        ld a,b
        and $07
        ld e,a
        add hl,de
        ld e,(hl)
        ld h,d
        srl b
        srl b
        srl b
        ld a,c
        add a,a
        add a,a
        ld l,a
        add hl,hl
        add hl,hl
        ld a,e
        ld e,b
        add hl,de
        pop de
        pop bc
        ret
ExpTable:
    .db $80,$40,$20,$10,$08,$04,$02,$01

DarkLayer:
 .db 16,1,64
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %01011111,%11111111,%11100000,%00000000,%00000000,%00000000,%00000000,%00000111,%11111111,%11110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00010000,%00000010,%01000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000010,%01100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00011111,%11111100,%00000000,%00000000,%00000000,%00000000,%00000000,%00111111,%11111101,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00001111,%11000011,%01111111,%11111000,%00111100,%00001111,%11111100,%00111110,%00000010,%01111111,%11000000,%00011110,%00000111,%11111111,%01111111,%11110000
 .db %00001111,%11000000,%11111111,%11111100,%11111110,%00011111,%11111111,%00111010,%00000001,%11111111,%11110000,%01111111,%00001111,%11111111,%01111111,%11110000
 .db %00000111,%10100001,%11100000,%00000101,%11000010,%01110000,%00000111,%01110010,%00000011,%10000000,%01111000,%01100001,%00111000,%00000111,%11000001,%10011000
 .db %00000011,%10010001,%10011011,%11000001,%11100000,%00011111,%00111100,%01100010,%00000000,%11111000,%10011000,%11110000,%10000111,%00000000,%00111110,%00001000
 .db %00000001,%11001000,%00000011,%11100001,%11111001,%00011111,%10001100,%01100010,%00000001,%11110000,%11011000,%11111100,%10001111,%10000000,%00111110,%00000000
 .db %00000000,%11000110,%00000011,%00100001,%00111101,%00011101,%10000001,%01100010,%00000001,%11010000,%11010000,%10011110,%00001110,%11111100,%00111001,%00000000
 .db %00000000,%11100100,%00000111,%00100001,%01111110,%10011101,%10000010,%01100010,%00000001,%11010001,%10000000,%10111110,%01001111,%11111000,%00111000,%00000000
 .db %00000000,%01110000,%00000111,%01100011,%00001110,%10011101,%10000100,%01110000,%00000001,%11010011,%00000001,%10000111,%01001110,%11100000,%00111000,%00000000
 .db %00000000,%00111001,%00000111,%11100011,%01110111,%10011101,%11011000,%01110011,%00000001,%11010011,%11000001,%10111111,%01101110,%01000000,%00111111,%00000000
 .db %00000000,%00011101,%10000011,%01100011,%11110011,%11001111,%11001100,%00100011,%10000001,%11110110,%11000001,%11111111,%10101111,%00000000,%00111011,%00000000
 .db %00001110,%11111110,%11100001,%01100110,%10000011,%01001001,%00111001,%10110011,%11000001,%10010011,%10010011,%01000001,%10000001,%00000000,%00011001,%00000000
 .db %00001111,%11111110,%11100000,%00000111,%10000011,%11011111,%00011111,%10011001,%11100101,%11111001,%11111011,%01000001,%10100111,%00000000,%00011011,%00000000
 .db %01100011,%11111000,%01100001,%10000111,%00000001,%11001110,%00001111,%10001100,%00100100,%11110000,%01110001,%00000000,%10100111,%00000000,%00011110,%00000000
 .db %01111100,%00000111,%11000000,%10000000,%00000000,%00000000,%00000000,%00000100,%10010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00001000,%00000000
 .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,%11111111,%11111111,%11111111,%11111111,%11111111,%11100000,%00000000,%00000000
 .db %00000000,%00000000,%01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%00001111,%11111111,%11111111,%11111111,%11111111,%11110000,%00000000,%00000000
 .db %00000000,%00000001,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111000,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%10111111,%10111111,%11111111,%11110111,%11111111,%11111111,%11111111,%11111000,%00000000,%00001000
 .db %11111111,%11111111,%11101111,%11101011,%11011001,%11001111,%10011011,%00111111,%01110110,%11100110,%11111110,%01111100,%11111110,%11111111,%11111111,%11111000
 .db %11111111,%11111111,%11101111,%11110111,%11011011,%10110111,%11101111,%11111111,%01110110,%11101111,%11111111,%11111100,%11111110,%11111111,%11111111,%11110000
 .db %00000111,%11111111,%11101111,%11101011,%11011111,%10110111,%11100111,%11100111,%01110110,%11101100,%11111111,%11011100,%11111110,%11111111,%11111111,%00000000
 .db %00000000,%00011111,%11111111,%11111111,%11111111,%11111111,%11110111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%10000000,%00000000
 .db %00000000,%00001111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%10000000,%00000000
 .db %00000000,%00000001,%11111111,%11111111,%11111111,%11110011,%11011011,%01110110,%00111100,%10011000,%11111111,%11111111,%11111111,%11100000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00110011,%11111011,%11111110,%00111101,%10111000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00110011,%11111011,%11110110,%00111101,%11111000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00001111,%11111111,%11111111,%11111111,%11111111,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000

.end